/*
 Produced by NSL Core(version=20110725), IP ARCH, Inc. Thu Apr 11 09:32:23 2013
 Licensed to :LIMITED EVALUATION USER:
*/
/*
 EVALUATION COPY!   DO NOT USE ANY PART OF THIS FILE FOR COMMERCIAL PRODUCTS. 
*/

module RGB2YCbCr_conv ( p_reset , m_clock , R_in , G_in , B_in , Y_out , Cb_out , Cr_out , VSYNCin , HSYNCin , VSYNCout , HSYNCout , ConvStart , ConvFinish );
  input p_reset, m_clock;
  wire p_reset, m_clock;
  input [7:0] R_in;
  wire [7:0] R_in;
  input [7:0] G_in;
  wire [7:0] G_in;
  input [7:0] B_in;
  wire [7:0] B_in;
  output [7:0] Y_out;
  wire [7:0] Y_out;
  output [7:0] Cb_out;
  wire [7:0] Cb_out;
  output [7:0] Cr_out;
  wire [7:0] Cr_out;
  input VSYNCin;
  wire VSYNCin;
  input HSYNCin;
  wire HSYNCin;
  output VSYNCout;
  wire VSYNCout;
  output HSYNCout;
  wire HSYNCout;
  input ConvStart;
  wire ConvStart;
  output ConvFinish;
  wire ConvFinish;
  reg [7:0] reg_Yout;
  reg [7:0] reg_Cbout;
  reg [7:0] reg_Crout;
  reg [3:0] shiftregs;
  reg [2:0] VSYNC_tmg;
  reg [2:0] HSYNC_tmg;
  wire [7:0] _Y_RGB2YCbCr_mac_Rin;
  wire [7:0] _Y_RGB2YCbCr_mac_Gin;
  wire [7:0] _Y_RGB2YCbCr_mac_Bin;
  wire [15:0] _Y_RGB2YCbCr_mac_COEF_Ain;
  wire [15:0] _Y_RGB2YCbCr_mac_COEF_Bin;
  wire [15:0] _Y_RGB2YCbCr_mac_COEF_Cin;
  wire [15:0] _Y_RGB2YCbCr_mac_COEF_Din;
  wire [7:0] _Y_RGB2YCbCr_mac_YCbCrout;
  wire _Y_RGB2YCbCr_mac_p_reset;
  wire _Y_RGB2YCbCr_mac_m_clock;
  wire [7:0] _Cb_RGB2YCbCr_mac_Rin;
  wire [7:0] _Cb_RGB2YCbCr_mac_Gin;
  wire [7:0] _Cb_RGB2YCbCr_mac_Bin;
  wire [15:0] _Cb_RGB2YCbCr_mac_COEF_Ain;
  wire [15:0] _Cb_RGB2YCbCr_mac_COEF_Bin;
  wire [15:0] _Cb_RGB2YCbCr_mac_COEF_Cin;
  wire [15:0] _Cb_RGB2YCbCr_mac_COEF_Din;
  wire [7:0] _Cb_RGB2YCbCr_mac_YCbCrout;
  wire _Cb_RGB2YCbCr_mac_p_reset;
  wire _Cb_RGB2YCbCr_mac_m_clock;
  wire [7:0] _Cr_RGB2YCbCr_mac_Rin;
  wire [7:0] _Cr_RGB2YCbCr_mac_Gin;
  wire [7:0] _Cr_RGB2YCbCr_mac_Bin;
  wire [15:0] _Cr_RGB2YCbCr_mac_COEF_Ain;
  wire [15:0] _Cr_RGB2YCbCr_mac_COEF_Bin;
  wire [15:0] _Cr_RGB2YCbCr_mac_COEF_Cin;
  wire [15:0] _Cr_RGB2YCbCr_mac_COEF_Din;
  wire [7:0] _Cr_RGB2YCbCr_mac_YCbCrout;
  wire _Cr_RGB2YCbCr_mac_p_reset;
  wire _Cr_RGB2YCbCr_mac_m_clock;
  wire _net_0;
RGB2YCbCr_Crmac Cr_RGB2YCbCr_mac (.p_reset(_Cr_RGB2YCbCr_mac_p_reset), .m_clock(_Cr_RGB2YCbCr_mac_m_clock), .YCbCrout(_Cr_RGB2YCbCr_mac_YCbCrout), .COEF_Din(_Cr_RGB2YCbCr_mac_COEF_Din), .COEF_Cin(_Cr_RGB2YCbCr_mac_COEF_Cin), .COEF_Bin(_Cr_RGB2YCbCr_mac_COEF_Bin), .COEF_Ain(_Cr_RGB2YCbCr_mac_COEF_Ain), .Bin(_Cr_RGB2YCbCr_mac_Bin), .Gin(_Cr_RGB2YCbCr_mac_Gin), .Rin(_Cr_RGB2YCbCr_mac_Rin));
RGB2YCbCr_Cbmac Cb_RGB2YCbCr_mac (.p_reset(_Cb_RGB2YCbCr_mac_p_reset), .m_clock(_Cb_RGB2YCbCr_mac_m_clock), .YCbCrout(_Cb_RGB2YCbCr_mac_YCbCrout), .COEF_Din(_Cb_RGB2YCbCr_mac_COEF_Din), .COEF_Cin(_Cb_RGB2YCbCr_mac_COEF_Cin), .COEF_Bin(_Cb_RGB2YCbCr_mac_COEF_Bin), .COEF_Ain(_Cb_RGB2YCbCr_mac_COEF_Ain), .Bin(_Cb_RGB2YCbCr_mac_Bin), .Gin(_Cb_RGB2YCbCr_mac_Gin), .Rin(_Cb_RGB2YCbCr_mac_Rin));
RGB2YCbCr_Ymac Y_RGB2YCbCr_mac (.p_reset(_Y_RGB2YCbCr_mac_p_reset), .m_clock(_Y_RGB2YCbCr_mac_m_clock), .YCbCrout(_Y_RGB2YCbCr_mac_YCbCrout), .COEF_Din(_Y_RGB2YCbCr_mac_COEF_Din), .COEF_Cin(_Y_RGB2YCbCr_mac_COEF_Cin), .COEF_Bin(_Y_RGB2YCbCr_mac_COEF_Bin), .COEF_Ain(_Y_RGB2YCbCr_mac_COEF_Ain), .Bin(_Y_RGB2YCbCr_mac_Bin), .Gin(_Y_RGB2YCbCr_mac_Gin), .Rin(_Y_RGB2YCbCr_mac_Rin));

   assign  _Y_RGB2YCbCr_mac_Rin = R_in;
   assign  _Y_RGB2YCbCr_mac_Gin = G_in;
   assign  _Y_RGB2YCbCr_mac_Bin = B_in;
   assign  _Y_RGB2YCbCr_mac_COEF_Ain = 16'b0000010011001000;
   assign  _Y_RGB2YCbCr_mac_COEF_Bin = 16'b0000100101100100;
   assign  _Y_RGB2YCbCr_mac_COEF_Cin = 16'b0000000111010011;
   assign  _Y_RGB2YCbCr_mac_COEF_Din = 16'b0000000000000000;
   assign  _Y_RGB2YCbCr_mac_p_reset = p_reset;
   assign  _Y_RGB2YCbCr_mac_m_clock = m_clock;
   assign  _Cb_RGB2YCbCr_mac_Rin = R_in;
   assign  _Cb_RGB2YCbCr_mac_Gin = G_in;
   assign  _Cb_RGB2YCbCr_mac_Bin = B_in;
   assign  _Cb_RGB2YCbCr_mac_COEF_Ain = 16'b0000001010110011;
   assign  _Cb_RGB2YCbCr_mac_COEF_Bin = 16'b0000010101001101;
   assign  _Cb_RGB2YCbCr_mac_COEF_Cin = 16'b0000100000000000;
   assign  _Cb_RGB2YCbCr_mac_COEF_Din = 16'b1000000000000000;
   assign  _Cb_RGB2YCbCr_mac_p_reset = p_reset;
   assign  _Cb_RGB2YCbCr_mac_m_clock = m_clock;
   assign  _Cr_RGB2YCbCr_mac_Rin = R_in;
   assign  _Cr_RGB2YCbCr_mac_Gin = G_in;
   assign  _Cr_RGB2YCbCr_mac_Bin = B_in;
   assign  _Cr_RGB2YCbCr_mac_COEF_Ain = 16'b0000100000000000;
   assign  _Cr_RGB2YCbCr_mac_COEF_Bin = 16'b0000011010110011;
   assign  _Cr_RGB2YCbCr_mac_COEF_Cin = 16'b0000000101001101;
   assign  _Cr_RGB2YCbCr_mac_COEF_Din = 16'b1000000000000000;
   assign  _Cr_RGB2YCbCr_mac_p_reset = p_reset;
   assign  _Cr_RGB2YCbCr_mac_m_clock = m_clock;
   assign  _net_0 = shiftregs[3];
   assign  Y_out = reg_Yout;
   assign  Cb_out = reg_Cbout;
   assign  Cr_out = reg_Crout;
   assign  VSYNCout = VSYNC_tmg[2];
   assign  HSYNCout = HSYNC_tmg[2];
   assign  ConvFinish = _net_0;
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     reg_Yout <= 8'b00000000;
else   reg_Yout <= _Y_RGB2YCbCr_mac_YCbCrout;
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     reg_Cbout <= 8'b00000000;
else   reg_Cbout <= _Cb_RGB2YCbCr_mac_YCbCrout;
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     reg_Crout <= 8'b00000000;
else   reg_Crout <= _Cr_RGB2YCbCr_mac_YCbCrout;
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     shiftregs <= 4'b0000;
else   shiftregs <= {shiftregs[2:0],ConvStart};
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     VSYNC_tmg <= 3'b000;
else   VSYNC_tmg <= {VSYNC_tmg[1:0],VSYNCin};
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     HSYNC_tmg <= 3'b000;
else   HSYNC_tmg <= {HSYNC_tmg[1:0],HSYNCin};
end
endmodule
/*
 Produced by NSL Core(version=20110725), IP ARCH, Inc. Thu Apr 11 09:32:23 2013
 Licensed to :LIMITED EVALUATION USER:
*/
