/*
 Produced by NSL Core(version=20110126), IP ARCH, Inc. Wed May 18 22:31:15 2011
 Licensed to :LIMITED EVALUATION USER:
*/

module YCbCr2RGB_Gmac ( p_reset , m_clock , Yin , Cbin , Crin , COEF_Ain , COEF_Bin , COEF_Cin , COEF_Din , RGBout );
  input p_reset, m_clock;
  input [7:0] Yin;
  input [7:0] Cbin;
  input [7:0] Crin;
  input [15:0] COEF_Ain;
  input [15:0] COEF_Bin;
  input [15:0] COEF_Cin;
  input [15:0] COEF_Din;
  output [7:0] RGBout;
  reg [23:0] nodeA;
  reg [23:0] nodeB;
  reg [23:0] nodeC;
  reg [15:0] nodeD;
  reg [23:0] nodeE;
  reg [23:0] nodeF;
  wire [7:0] nodeRESULT;
  wire _net_0;
  wire _net_1;
  wire _net_2;
  wire _net_3;
  wire _net_4;
  wire _net_5;
  wire _net_6;

   assign #1 nodeRESULT = ((_net_6)?nodeF[19:12]:8'b0)|
    ((_net_5)?8'b11111111:8'b0)|
    ((_net_2)?8'b00000000:8'b0);
   assign #1 _net_0 = nodeE[11];
   assign #1 _net_1 = ~_net_0;
   assign #1 _net_2 = (nodeF[21])==(1'b1);
   assign #1 _net_3 = (nodeF[20])==(1'b1);
   assign #1 _net_4 = ~_net_2;
   assign #1 _net_5 = (~_net_2)&_net_3;
   assign #1 _net_6 = (~_net_2)&(~_net_3);
   assign #1 RGBout = nodeRESULT;
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeA <= 24'b000000000000000000000000;
else   nodeA <= (Yin)*(COEF_Ain);
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeB <= 24'b000000000000000000000000;
else   nodeB <= (Cbin)*(COEF_Bin);
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeC <= 24'b000000000000000000000000;
else   nodeC <= (Crin)*(COEF_Cin);
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeD <= 16'b0000000000000000;
else   nodeD <= COEF_Din;
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeE <= 24'b000000000000000000000000;
else   nodeE <= (((nodeA)+(~nodeB))+(~nodeC))+({4'b0000,nodeD,4'b0000});
end
always @(posedge m_clock or posedge p_reset)
  begin
if (p_reset)
     nodeF <= 24'b000000000000000000000000;
else if ((_net_1)|(_net_0)) 
      nodeF <= ((_net_1) ?nodeE[23:0]:24'b0)|
    ((_net_0) ?(nodeE[23:0])+(24'b000000000001000000000000):24'b0);

end
endmodule
/*
 Produced by NSL Core(version=20110126), IP ARCH, Inc. Wed May 18 22:31:15 2011
 Licensed to :LIMITED EVALUATION USER:
*/
